<?php
namespace FiloBlu\Flow\Model\Filters;

/**
 * Class Mannequin
 * @package FiloBlu\Flow\Model\Filters
 */
class Mannequin extends \FiloBlu\Flow\Model\Filters\AbstractFilter
{
    /**
     * @var integer
     */
    const LABEL_INDEX = 0;
    /**
     * @var integer
     */
    const VALUE_INDEX = 1;
    /**
     * @var integer
     */
    const EXPECTED_COUNT = 2;

    /**
     * @param $value
     * @param $args
     * @return string
     */
    public function filter($value, $args)
    {
        $attributes = $args['attributes'];
        $row = $this->getRow();

        $output = [];

        foreach ($attributes as $name => $index) {
            $values = explode('|', $row[$index]);

            if (count($values) !== self::EXPECTED_COUNT) {
                return null;
            }

            $output[$name] = [
                'label' => $values[self::LABEL_INDEX],
                'value' => $values[self::VALUE_INDEX]
            ];
        }

        $json = json_encode($output);

        if (json_last_error() === JSON_ERROR_NONE) {
            return $json;
        }

        return null;
    }
}